package ru.landgrafhomyak.db.skeleton1.api.errors

import kotlin.jvm.JvmStatic
import kotlinx.coroutines.CopyableThrowable
import kotlinx.coroutines.ExperimentalCoroutinesApi
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi
import ru.landgrafhomyak.db.skeleton1.api.statement.InputParam
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement

@ReflectionApi
@OptIn(ExperimentalCoroutinesApi::class)
public class AccessWhileInitializationException : IllegalStateException, CopyableThrowable<AccessWhileInitializationException> {
	public val scope: Any
	public val `object`: Any
	public val member: Any

	public constructor(scope: Any, `object`: Any, member: Any) : super() {
		this.scope = scope
		this.`object` = `object`
		this.member = member
	}

	public constructor(scope: Any, `object`: Any, member: Any, customMessage: String) : super(customMessage) {
		this.scope = scope
		this.`object` = `object`
		this.member = member
	}

	public constructor(scope: Any, `object`: Any, member: Any, customMessage: String, cause: Throwable) : super(customMessage, cause) {
		this.scope = scope
		this.`object` = `object`
		this.member = member
	}

	public constructor(scope: Any, `object`: Any, member: Any, cause: Throwable) : super(cause) {
		this.scope = scope
		this.`object` = `object`
		this.member = member
	}

	public constructor(
		scope: Any, `object`: Any, member: Any,
		message: String?,
		cause: Throwable?,
		@Suppress("unused", "LocalVariableName") _marker: Unit
	) : super(message, cause) {
		this.scope = scope
		this.`object` = `object`
		this.member = member
	}


	override fun createCopy(): AccessWhileInitializationException? {
		return AccessWhileInitializationException(
			scope = this.scope,
			`object` = this.`object`,
			member = this.member,
			message = this.message,
			cause = this.cause,
			_marker = Unit
		)
	}

	public companion object {
		@JvmStatic
		public fun formatMessage(scope: Any, `object`: Any, member: Any): String =
			"Attempt to access $member of $`object` before it's producer scope $scope not finished"
	}
}