package ru.landgrafhomyak.db.skeleton1.api.errors.definition

import kotlinx.coroutines.CopyableThrowable
import kotlinx.coroutines.ExperimentalCoroutinesApi
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi
import ru.landgrafhomyak.db.skeleton1.api.errors.SchemaDefinitionException

@ReflectionApi
@OptIn(ExperimentalCoroutinesApi::class)
public class IncorrectNameException : SchemaDefinitionException, CopyableThrowable<IncorrectNameException> {
	public val name: String

	public constructor(name: String) : super(name) {
		this.name = name
	}

	public constructor(name: String, customMessage: String) : super(customMessage) {
		this.name = name
	}

	public constructor(name: String, customMessage: String, cause: Throwable) : super(customMessage, cause) {
		this.name = name
	}

	public constructor(name: String, cause: Throwable) : super(name, cause) {
		this.name = name
	}

	public constructor(
		name: String,
		message: String?,
		cause: Throwable?,
		@Suppress("unused", "LocalVariableName") _marker: Unit
	) : super(message, cause, _marker) {
		this.name = name
	}


	override fun createCopy(): IncorrectNameException? {
		return IncorrectNameException(
			name = this.name,
			message = this.message,
			cause = this.cause,
			_marker = Unit
		)
	}
}