package ru.landgrafhomyak.db.skeleton1.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi
import ru.landgrafhomyak.db.skeleton1.api.ObjectOperations

public interface ModuleScopedObject<oUE : Any?, mUE : Any> {
	public val uExt: oUE

	@ReflectionApi
	public val name: String

	@ReflectionApi
	public val module: Module<mUE>

	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getPathFromModuleRoot")
	public val pathFromModuleRoot: List<String>

	@ReflectionApi
	public val meta: ObjectOperations.ImplementationsProvider<oUE>

	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("willBeDeletedAfterUpgrade")
	public val willBeDeletedAfterUpgrade: Boolean
}